"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by tushar on 15/01/17.
 */
const ava_1 = require("ava");
const hoe_1 = require("../hoe");
exports.testListener = () => {
    const actions = [];
    const listener = (action) => {
        actions.push(action);
    };
    return { actions, listener };
};
ava_1.default(t => {
    const { actions, listener } = exports.testListener();
    const e = hoe_1.create(listener);
    e.emit(100);
    e.emit(200);
    t.deepEqual(actions, [100, 200]);
});
ava_1.default('of()', t => {
    const { actions, listener } = exports.testListener();
    const e = hoe_1.create(listener).of('T');
    e.emit(100);
    e.emit(200);
    t.deepEqual(actions, [
        hoe_1.action('T', 100),
        hoe_1.action('T', 200)
    ]);
});
ava_1.default('of(A).of(B)', t => {
    const { actions, listener } = exports.testListener();
    const e = hoe_1.create(listener).of('A').of('B');
    e.emit(100);
    e.emit(200);
    t.deepEqual(actions, [
        hoe_1.action('A', hoe_1.action('B', 100)),
        hoe_1.action('A', hoe_1.action('B', 200))
    ]);
});
ava_1.default('emit.bind()', t => {
    const { actions, listener } = exports.testListener();
    const e = hoe_1.create(listener);
    const f = e.of('F');
    e.emit.call(null, 100);
    f.emit.call(null, 200);
    t.deepEqual(actions, [
        100,
        hoe_1.action('F', 200)
    ]);
});
//# sourceMappingURL=test.hoe.js.map